#region File Header
// /////////////////////////////////////////////////////////////
// File: AboutForm.cs	Class: Kennedy.Controls.SampleApp.MainForm
// Date:10/21/2004		Author: Michael Kennedy
// Language: C#			Framework: .NET
//
// Copyright: Copyright (c) Michael Kennedy, 2004
// /////////////////////////////////////////////////////////////
#endregion

#region using ...
using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
#endregion

namespace Kennedy.Controls.SampleApp
{
	public class MainForm : System.Windows.Forms.Form
	{
		#region Non-sample Related Member Variables
		private System.Windows.Forms.RadioButton radioButtonFloatingPoint;
		private System.Windows.Forms.RadioButton radioButtonFloatingPointNonNegative;
		private System.Windows.Forms.RadioButton radioButtonInteger;
		private System.Windows.Forms.RadioButton radioButtonIntegerNonNegative;
		private System.Windows.Forms.RadioButton radioButtonNatural;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItemFile;
		private System.Windows.Forms.MenuItem menuItemFile_Exit;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private System.Windows.Forms.MenuItem menuItemHelp_About;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.GroupBox groupBoxNumerical;
		private System.Windows.Forms.GroupBox groupBoxSSN;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label labelSSNValue;
		private System.Windows.Forms.Label labelNumericalValue;
		private System.Windows.Forms.Label label7;
		private System.ComponentModel.Container components = null;
		#endregion

		#region Sample Related Member Variables

		private Kennedy.Controls.NumericalTextBox textBoxNumber;
		private Kennedy.Controls.SSNTextBox textBoxSSN;

		#endregion

		#region Construction and Cleanup

		public MainForm()
		{
			//
			// Required for Windows Form Designer support.
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call.
			//
			SetNumberTypeChecks();
			textBoxNumber.Select(1, 0);

			//
			// Ensure the INVALID label text is properly set and consistent
			// with any design-time changes.
			//
			textBoxNumber.RevalidateText();
			textBoxSSN.RevalidateText();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxNumber = new Kennedy.Controls.NumericalTextBox();
			this.radioButtonFloatingPoint = new System.Windows.Forms.RadioButton();
			this.radioButtonFloatingPointNonNegative = new System.Windows.Forms.RadioButton();
			this.radioButtonInteger = new System.Windows.Forms.RadioButton();
			this.radioButtonIntegerNonNegative = new System.Windows.Forms.RadioButton();
			this.radioButtonNatural = new System.Windows.Forms.RadioButton();
			this.textBoxSSN = new Kennedy.Controls.SSNTextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItemFile = new System.Windows.Forms.MenuItem();
			this.menuItemFile_Exit = new System.Windows.Forms.MenuItem();
			this.menuItemHelp = new System.Windows.Forms.MenuItem();
			this.menuItemHelp_About = new System.Windows.Forms.MenuItem();
			this.label6 = new System.Windows.Forms.Label();
			this.groupBoxNumerical = new System.Windows.Forms.GroupBox();
			this.labelNumericalValue = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.groupBoxSSN = new System.Windows.Forms.GroupBox();
			this.labelSSNValue = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.groupBoxNumerical.SuspendLayout();
			this.groupBoxSSN.SuspendLayout();
			this.SuspendLayout();
			// 
			// textBoxNumber
			// 
			this.textBoxNumber.Location = new System.Drawing.Point(8, 36);
			this.textBoxNumber.Name = "textBoxNumber";
			this.textBoxNumber.NumberType = Kennedy.Controls.NumericalTextBox.NumericalTypes.FloatingPointNonNegative;
			this.textBoxNumber.TabIndex = 0;
			this.textBoxNumber.Text = "1";
			this.textBoxNumber.Value = 1;
			this.textBoxNumber.ValueChanged += new System.EventHandler(this.textBoxNumber_ValueChanged);
			// 
			// radioButtonFloatingPoint
			// 
			this.radioButtonFloatingPoint.Checked = true;
			this.radioButtonFloatingPoint.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.radioButtonFloatingPoint.Location = new System.Drawing.Point(120, 40);
			this.radioButtonFloatingPoint.Name = "radioButtonFloatingPoint";
			this.radioButtonFloatingPoint.Size = new System.Drawing.Size(160, 16);
			this.radioButtonFloatingPoint.TabIndex = 2;
			this.radioButtonFloatingPoint.TabStop = true;
			this.radioButtonFloatingPoint.Text = "Floating Point";
			this.radioButtonFloatingPoint.CheckedChanged += new System.EventHandler(this.radioButtonNumberTypes_CheckedChanged);
			// 
			// radioButtonFloatingPointNonNegative
			// 
			this.radioButtonFloatingPointNonNegative.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.radioButtonFloatingPointNonNegative.Location = new System.Drawing.Point(120, 60);
			this.radioButtonFloatingPointNonNegative.Name = "radioButtonFloatingPointNonNegative";
			this.radioButtonFloatingPointNonNegative.Size = new System.Drawing.Size(160, 16);
			this.radioButtonFloatingPointNonNegative.TabIndex = 3;
			this.radioButtonFloatingPointNonNegative.Text = "Floating Point Non-negative";
			this.radioButtonFloatingPointNonNegative.CheckedChanged += new System.EventHandler(this.radioButtonNumberTypes_CheckedChanged);
			// 
			// radioButtonInteger
			// 
			this.radioButtonInteger.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.radioButtonInteger.Location = new System.Drawing.Point(120, 80);
			this.radioButtonInteger.Name = "radioButtonInteger";
			this.radioButtonInteger.Size = new System.Drawing.Size(160, 16);
			this.radioButtonInteger.TabIndex = 4;
			this.radioButtonInteger.Text = "Integer";
			this.radioButtonInteger.CheckedChanged += new System.EventHandler(this.radioButtonNumberTypes_CheckedChanged);
			// 
			// radioButtonIntegerNonNegative
			// 
			this.radioButtonIntegerNonNegative.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.radioButtonIntegerNonNegative.Location = new System.Drawing.Point(120, 100);
			this.radioButtonIntegerNonNegative.Name = "radioButtonIntegerNonNegative";
			this.radioButtonIntegerNonNegative.Size = new System.Drawing.Size(160, 16);
			this.radioButtonIntegerNonNegative.TabIndex = 5;
			this.radioButtonIntegerNonNegative.Text = "Integer Non-negative";
			this.radioButtonIntegerNonNegative.CheckedChanged += new System.EventHandler(this.radioButtonNumberTypes_CheckedChanged);
			// 
			// radioButtonNatural
			// 
			this.radioButtonNatural.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.radioButtonNatural.Location = new System.Drawing.Point(120, 120);
			this.radioButtonNatural.Name = "radioButtonNatural";
			this.radioButtonNatural.Size = new System.Drawing.Size(160, 16);
			this.radioButtonNatural.TabIndex = 6;
			this.radioButtonNatural.Text = "Natural (1, 2, 3, ...)";
			this.radioButtonNatural.CheckedChanged += new System.EventHandler(this.radioButtonNumberTypes_CheckedChanged);
			// 
			// textBoxSSN
			// 
			this.textBoxSSN.Location = new System.Drawing.Point(8, 36);
			this.textBoxSSN.Name = "textBoxSSN";
			this.textBoxSSN.Size = new System.Drawing.Size(116, 20);
			this.textBoxSSN.TabIndex = 0;
			this.textBoxSSN.Text = "";
			this.textBoxSSN.ValueChanged += new System.EventHandler(this.textBoxSSN_ValueChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(128, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Social Security TextBox";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 20);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(104, 16);
			this.label2.TabIndex = 7;
			this.label2.Text = "Numerical TextBox";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F);
			this.label3.Location = new System.Drawing.Point(8, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(596, 36);
			this.label3.TabIndex = 2;
			this.label3.Text = "Type text in the TextBoxes below to explore how they use regular expressions to p" +
				"rovide instantaneous feedback and validation.";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(120, 20);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(160, 16);
			this.label4.TabIndex = 1;
			this.label4.Text = "Choose Number Type";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemFile,
																					  this.menuItemHelp});
			// 
			// menuItemFile
			// 
			this.menuItemFile.Index = 0;
			this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemFile_Exit});
			this.menuItemFile.Text = "&File";
			// 
			// menuItemFile_Exit
			// 
			this.menuItemFile_Exit.Index = 0;
			this.menuItemFile_Exit.Text = "E&xit";
			this.menuItemFile_Exit.Click += new System.EventHandler(this.menuItemFile_Exit_Click);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 1;
			this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemHelp_About});
			this.menuItemHelp.Text = "&Help";
			// 
			// menuItemHelp_About
			// 
			this.menuItemHelp_About.Index = 0;
			this.menuItemHelp_About.Text = "&About";
			this.menuItemHelp_About.Click += new System.EventHandler(this.menuItemHelp_About_Click);
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(140, 20);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(152, 44);
			this.label6.TabIndex = 1;
			this.label6.Text = "Input must be of the form NNN-NN-NNNN where N is a number (0-9).";
			// 
			// groupBoxNumerical
			// 
			this.groupBoxNumerical.Controls.Add(this.labelNumericalValue);
			this.groupBoxNumerical.Controls.Add(this.textBoxNumber);
			this.groupBoxNumerical.Controls.Add(this.radioButtonFloatingPoint);
			this.groupBoxNumerical.Controls.Add(this.radioButtonFloatingPointNonNegative);
			this.groupBoxNumerical.Controls.Add(this.radioButtonInteger);
			this.groupBoxNumerical.Controls.Add(this.radioButtonIntegerNonNegative);
			this.groupBoxNumerical.Controls.Add(this.radioButtonNatural);
			this.groupBoxNumerical.Controls.Add(this.label2);
			this.groupBoxNumerical.Controls.Add(this.label4);
			this.groupBoxNumerical.Controls.Add(this.label7);
			this.groupBoxNumerical.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBoxNumerical.Location = new System.Drawing.Point(8, 48);
			this.groupBoxNumerical.Name = "groupBoxNumerical";
			this.groupBoxNumerical.Size = new System.Drawing.Size(288, 144);
			this.groupBoxNumerical.TabIndex = 0;
			this.groupBoxNumerical.TabStop = false;
			this.groupBoxNumerical.Text = "Numerical TextBox";
			// 
			// labelNumericalValue
			// 
			this.labelNumericalValue.Location = new System.Drawing.Point(8, 80);
			this.labelNumericalValue.Name = "labelNumericalValue";
			this.labelNumericalValue.Size = new System.Drawing.Size(100, 16);
			this.labelNumericalValue.TabIndex = 9;
			this.labelNumericalValue.Text = "INVALID";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 60);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(100, 16);
			this.label7.TabIndex = 8;
			this.label7.Text = "Current Value";
			// 
			// groupBoxSSN
			// 
			this.groupBoxSSN.Controls.Add(this.labelSSNValue);
			this.groupBoxSSN.Controls.Add(this.label5);
			this.groupBoxSSN.Controls.Add(this.label6);
			this.groupBoxSSN.Controls.Add(this.textBoxSSN);
			this.groupBoxSSN.Controls.Add(this.label1);
			this.groupBoxSSN.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBoxSSN.Location = new System.Drawing.Point(300, 48);
			this.groupBoxSSN.Name = "groupBoxSSN";
			this.groupBoxSSN.Size = new System.Drawing.Size(300, 144);
			this.groupBoxSSN.TabIndex = 1;
			this.groupBoxSSN.TabStop = false;
			this.groupBoxSSN.Text = "Social Security TextBox";
			// 
			// labelSSNValue
			// 
			this.labelSSNValue.Location = new System.Drawing.Point(8, 80);
			this.labelSSNValue.Name = "labelSSNValue";
			this.labelSSNValue.Size = new System.Drawing.Size(116, 16);
			this.labelSSNValue.TabIndex = 4;
			this.labelSSNValue.Text = "INVALID";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 60);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(116, 16);
			this.label5.TabIndex = 3;
			this.label5.Text = "Current Value";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(614, 203);
			this.Controls.Add(this.groupBoxSSN);
			this.Controls.Add(this.groupBoxNumerical);
			this.Controls.Add(this.label3);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Self Validating Controls Sample";
			this.groupBoxNumerical.ResumeLayout(false);
			this.groupBoxSSN.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Windows Forms Event Handlers

		private void menuItemFile_Exit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void menuItemHelp_About_Click(object sender, System.EventArgs e)
		{
			new AboutForm().ShowDialog();
		}

		#endregion

		#region NumericalTextBox NumberType Management Code

		private void radioButtonNumberTypes_CheckedChanged(object sender, System.EventArgs e)
		{
			SetNumberType();
		}

		private void SetNumberType()
		{
			if (radioButtonFloatingPoint.Checked)
			{
				textBoxNumber.NumberType = NumericalTextBox.NumericalTypes.FloatingPoint;
			}
			else if (radioButtonFloatingPointNonNegative.Checked)
			{
				textBoxNumber.NumberType = NumericalTextBox.NumericalTypes.FloatingPointNonNegative;
			}
			else if (radioButtonInteger.Checked)
			{
				textBoxNumber.NumberType = NumericalTextBox.NumericalTypes.Integer;
			}
			else if (radioButtonIntegerNonNegative.Checked)
			{
				textBoxNumber.NumberType = NumericalTextBox.NumericalTypes.IntegerNonNegative;
			}
			else if (radioButtonNatural.Checked)
			{
				textBoxNumber.NumberType = NumericalTextBox.NumericalTypes.Natural;
			}

			//
			// The current text may no longer be valid using the new number type.
			//
			if (!textBoxNumber.IsValidPartial)
			{
				textBoxNumber.Text = string.Empty;
			}
		}

		private void SetNumberTypeChecks()
		{
			switch (textBoxNumber.NumberType)
			{
				case NumericalTextBox.NumericalTypes.FloatingPoint:
					radioButtonFloatingPoint.Checked = true;
					break;
				case NumericalTextBox.NumericalTypes.FloatingPointNonNegative:
					radioButtonFloatingPointNonNegative.Checked = true;
					break;
				case NumericalTextBox.NumericalTypes.Integer:
					radioButtonInteger.Checked = true;
					break;
				case NumericalTextBox.NumericalTypes.IntegerNonNegative:
					radioButtonIntegerNonNegative.Checked = true;
					break;
				case NumericalTextBox.NumericalTypes.Natural:
					radioButtonNatural.Checked = true;
					break;
			}
		}

		#endregion

		#region ValudChanged Event Handlers

		private void textBoxSSN_ValueChanged(object sender, System.EventArgs e)
		{
			if (textBoxSSN.IsValid)
			{
				labelSSNValue.Text = textBoxSSN.Text;
			}
			else
			{
				labelSSNValue.Text = "INVALID";
			}
		}

		private void textBoxNumber_ValueChanged(object sender, System.EventArgs e)
		{
			if (textBoxNumber.IsValid)
			{
				labelNumericalValue.Text = textBoxNumber.Value.ToString();
			}
			else
			{
				labelNumericalValue.Text = "INVALID";
			}
		}

		#endregion

	}
}
